package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;

public class DERTaggedObject extends ASN1TaggedObject {
   public DERTaggedObject(int tagNo, DEREncodable obj) {
      super(tagNo, obj);
   }

   public DERTaggedObject(boolean explicit, int tagNo, DEREncodable obj) {
      super(explicit, tagNo, obj);
   }

   public DERTaggedObject(int tagNo) {
      DERTaggedObject var10000 = this;
      DERSequence var2;
      var2 = new DERSequence.<init>();
      var10000.<init>(false, tagNo, var2);
   }

   void encode(DEROutputStream out) {
      if (!super.empty) {
         ByteArrayOutputStream var2;
         ByteArrayOutputStream var10001 = var2 = new ByteArrayOutputStream;
         var10001.<init>();
         DEROutputStream var10002 = new DEROutputStream(var2);
         var10002.writeObject(super.obj);
         var10002.close();
         byte[] var3 = var10001.toByteArray();
         if (super.explicit) {
            out.writeEncoded(super.tagNo | 160, var3);
         } else {
            if ((var3[0] & 32) != 0) {
               var3[0] = (byte)(super.tagNo | 160);
            } else {
               var3[0] = (byte)(super.tagNo | 128);
            }

            out.write(var3);
         }
      } else {
         out.writeEncoded(super.tagNo | 160, new byte[0]);
      }

   }
}
